function [allwindows_train, allimages_train, allwindows_test, allimages_test, classes] = collectallwindows()

trainset = importdata('D:\VOC2007forCrack\ImageSets\Main\train.txt');
testset = importdata('D:\VOC2007forCrack\ImageSets\Main\test.txt');
classes = importdata('D:\VOC2007forCrack\ImageSets\Main\class.txt');
iids = dir('D:\VOC2007forCrack\Annotations\*.yml');
allwindows_train = cell(1, numel(trainset));
allimages_train = zeros(numel(trainset), 2);
allwindows_test = cell(1, numel(testset));
allimages_test = zeros(numel(testset), 2);
for i = 1 : numel(trainset)
    if mod(i, 100) == 0
        disp(i);
    end
    allwindows_train{i} = loadBBoxes(sprintf('D:\\VOC2007forCrack\\Annotations\\%s.yml', ...
        iids(trainset(i)).name(1 : end - 4)));
    im = imread(sprintf('D:\\VOC2007forCrack\\JPEGImages\\%s.jpg', iids(trainset(i)).name(1 : end - 4)));
    allimages_train(i, 1) = size(im, 1);
    allimages_train(i, 2) = size(im, 2);
end
for i = 1 : numel(testset)
    if mod(i, 100) == 0
        disp(i);
    end
    allwindows_test{i} = loadBBoxes(sprintf('D:\\VOC2007forCrack\\Annotations\\%s.yml', ...
        iids(testset(i)).name(1 : end - 4)));
    im = imread(sprintf('D:\\VOC2007forCrack\\JPEGImages\\%s.jpg', iids(testset(i)).name(1 : end - 4)));
    allimages_test(i, 1) = size(im, 1);
    allimages_test(i, 2) = size(im, 2);
end

end