/************************************************************************/
/* This source code is free for both academic and industry use.         */
/* Some important information for better using the source code could be */
/* found in the project page: http://mmcheng.net/bing					*/
/************************************************************************/

#include "stdafx.h"
#include "Objectness.h"
#include "ValStructVec.h"
#include "CmShow.h"

// Uncomment line line 14 in Objectness.cpp to remove counting times of image reading.

void RunObjectness(CStr &resName, double base, int W, int NSS, int numPerSz, int seed);

int main(int argc, char* argv[])
{
	RunObjectness("WinRecall.m", 2, 8, 2, 130, atoi(argv[1]));
//	RunObjectness("WinRecall.m", 2, 8, 2, 250);
	return 0;
}

void RunObjectness(CStr &resName, double base, int W, int NSS, int numPerSz, int seed)
{
	srand((unsigned int)time(NULL));
	DataSetVOC voc2007("C:/CrackingBING/VOC2007forCrack/");
	voc2007.loadAnnotations();

	printf("Dataset:`%s' with %d training and %d testing\n", _S(voc2007.wkDir), voc2007.trainNum, voc2007.testNum);
	printf("%s Base = %g, W = %d, NSS = %d, perSz = %d\n", _S(resName), base, W, NSS, numPerSz);
	
	Objectness objNess(voc2007, base, W, NSS, seed);

	vector<vector<Vec4i>> boxesTests;

	objNess.getObjBndBoxesForTestsFast(boxesTests, numPerSz);
//	objNess.getRandomBoxes(boxesTests, 1000);
}

